package legion.muyue.best2048;

import android.util.Log;
import java.util.ArrayList;
import java.util.Random;

public class Game {

    private int[][] gameBoard;
    private Random random;

    public Game() {
        gameBoard = new int[4][4];
        random = new Random();
    }

    public void printArray() {
        for (int[] row : gameBoard) {
            // Ajout de %n pour un retour à la ligne après chaque ligne de la grille
            String rowString = String.format("%6d%6d%6d%6d%n", row[0], row[1], row[2], row[3]);
            Log.d("Game", rowString);
        }
        // Ajout d'une ligne vide pour séparer les affichages de grille dans le Logcat
        Log.d("Game", "\n");
    }

    // Pas de changement dans la logique de addNewNumbers ici
    public void addNewNumbers() {
        ArrayList<int[]> emptySpaces = new ArrayList<>();

        for (int x = 0; x < 4; x++) {
            for (int y = 0; y < 4; y++) {
                if (gameBoard[x][y] == 0) {
                    emptySpaces.add(new int[]{x, y});
                }
            }
        }

        if (!emptySpaces.isEmpty()) {
            int choice = random.nextInt(emptySpaces.size());
            int[] coordinates = emptySpaces.get(choice);
            int x = coordinates[0];
            int y = coordinates[1];
            int newNumber;
            int randomNumber = random.nextInt(100);
            if (randomNumber < 85) {
                newNumber = 2;
            } else if (randomNumber < 95) {
                newNumber = 4;
            } else {
                newNumber = 8;
            }
            gameBoard[x][y] = newNumber;
        }
    }
    
    public void pushUp() {
        // La logique pour le mouvement vers le haut sera implémentée ici
    }
}